<?php
namespace Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use Teknisa\GER\Utilities\Environment;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\Controller;
use Zeedhi\Framework\Controller\Crud;
use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DTO\Response\Notification;


class Ger80400ApuracaoDemonstrativoController extends \Teknisa\Libs\Controller\CRUD{
	protected $dataSourceName = 'lista';
	protected $crudService;
	protected $dataSourceManager;
	protected $newCode;
	protected $entityManager;
	protected $connection;
	
	
	public function __construct($crudService, $environment, $dataSourceManager, $entityManager, $newCode, $connection) {
		parent::__construct($crudService, $environment);
		  
		  $this->environment       = $environment;
		  $this->dataSourceManager = $dataSourceManager;
		  $this->entityManager     = $entityManager;
		  $this->newCode           = $newCode;
		  $this->connection        = $connection;
	}
	
	public function atualizaPeriodo(DTO\Request $request,  DTO\Response $response){
        $dados = $request->getDataSet();
        
        if(!empty($dados)){
                $currentRow = $dados->getRows()[0];
                $result = array();
		        foreach ($currentRow["CDFILIAL"] as $cdfilial) {
		        	
			        $stmt = $this->connection->prepare("
						SELECT COUNT(*)
						  FROM DATAAPURACAOROP
						 WHERE CDFILIAL = :P_CDFILIAL"
					);
					$stmt->execute(
						array(
							'P_CDFILIAL' => $cdfilial
						)
					);
					array_push($result, $stmt->fetchAll());
		        }
           if(!empty($currentRow)){
               try{
               		$count = 0;
                    foreach ($currentRow["CDFILIAL"] as $cdfilial) {
                    	if($result[$count][0]['COUNT(*)'] == 0){
					        $currentTime = $this->crudService->getEnvironment()->getCurrentTime()->format("d/m/Y H:i:s");
					        $nrorg = $this->crudService->getEnvironment()->getNrOrg();
					        $cdoperador = $this->crudService->getEnvironment()->getCdOperador();
					        $rowToSave = array();
					        $nrdataapuracaorop = $this->newCode->getCodeByTableName('DATAAPURACAOROP', $this->environment->getNrOrgTrab());
							
							$rowToSave[0]['NRORG'] = $nrorg;
					        $rowToSave[0]['DTINCLUSAO'] = $currentTime;
							$rowToSave[0]['NRORGINCLUSAO'] = $nrorg;
							$rowToSave[0]['CDOPERINCLUSAO'] = $cdoperador;
							$rowToSave[0]['IDATIVO'] = 'S';
							$rowToSave[0]['DTULTATU'] = $currentTime;
							$rowToSave[0]['NRORGULTATU'] = $nrorg;
							$rowToSave[0]['CDOPERULTATU'] = $cdoperador;
							$rowToSave[0]['DTINIAPURACROP'] = $currentRow['DTINIAPURACROP'];
							$rowToSave[0]['DTFINAPURACROP'] = $currentRow['DTFINAPURACROP'];
							$rowToSave[0]['NRDATAAPURACAOROP'] = $nrdataapuracaorop;
							$rowToSave[0]['__is_new'] = true;
							$rowToSave[0]['__isSelected'] = true;
							$rowToSave[0]['__rightActions'] = array();
							$rowToSave[0]['__leftActions'] = array();
							$rowToSave[0]['__index'] = 0;
							$rowToSave[0]['CDFILIAL'] = $cdfilial;
							 try{
					            $this->crudService->save('dataapuracaorop', $rowToSave);
					        }catch(\Exception $ex){
					            $response->setError(new Error("ERRO_OPERACAO2" . $ex->getMessage(), 500));
					        }

            		   	}else {
	                        $stmt = $this->connection->prepare("
	                        UPDATE 
	                            DATAAPURACAOROP
	                        SET
	                            DTINIAPURACROP = :P_DTINIAPURACROP,
	                            DTFINAPURACROP = :P_DTFINAPURACROP
	                        WHERE
	                            CDFILIAL = :P_CDFILIAL");
	                        $stmt->execute(
	                            array(
	                                'P_DTINIAPURACROP' => $currentRow["DTINIAPURACROP"],
	                                'P_DTFINAPURACROP' => $currentRow["DTFINAPURACROP"],
	                                'P_CDFILIAL'       => $cdfilial
	                            )
	                        );
                    	}	                     
                        $count++;
                    }
               }catch(\Exception $ex){
	               $response->setError(new Error("Não foi possível processar os dados enviados.", 500));
	            }
            } 
        }
    }
	
	public function apura(DTO\Request $request,  DTO\Response $response) {
		$rows = $request->getDataSet()->getRows();
		$currentTime = $this->environment->getCurrentTime()->format("d/m/Y H:i:s");
		
		$filiais = '';
		
		try{
			// if($this->verificaParametros()) {
		        if(empty($rows))
		        throw new \Exception("Nao foi possivel realizar a operação. Selecione as unidades a serem apuradas.");
		        
	        	// if($this->verificaParametros($row));
		        foreach($rows as $row){
		        	$nrLista = $this->newCode->getCodeByTableName('LISTA', $this->environment->getNrOrgTrab());
		        	$lista = array();
	        		$lista["NRLISTA"] = $nrLista;
	        		$lista["CDLISTA"] = $row['CDFILIAL'];
	        		$lista["__is_new"] = true;
	        		$lista["DTULTATULIST"] = $currentTime;
	        		$lista["DTINCLUSAO"] = $currentTime;
	        		$lista["DTULTATU"] = "";
	        		$lista["NRORGINCLUSAO"] = $row['NRORG'];
	        		$lista["CDOPERINCLUSAO"] = "";
	        		$lista["NRORGULTATU"] = "";
	        		$lista["CDOPERULTATU"] = "";
	        		$lista["IDATIVO"] = "";
	        		$lista["NRORG"] = $row['NRORG'];
	        		$lista["IDATIVO"] = 'S';
	        		
	        		$rowsToSave[] = $lista ;
	        		$filiais = $filiais.$row['CDFILIAL'];
	        		// array_push($filiais, $row['CDFILIAL']);
		        }
		        
		        $this->crudService->save($this->dataSourceName, $rowsToSave);
		        
				if($nrLista){
					try {
						$procedure = new StoredProcedure($this->entityManager->getConnection(), 'APURAC_GESROP');
						$procedure->addParam(new Param('NRLISTA', Param::PARAM_INPUT, $nrLista,Param::PARAM_TYPE_STR));
						$procedure->execute();
				
					} catch (\Exception $e) {
						$response->setError(new DTO\Response\Error($e->getMessage(), 1));
					}	
				}
				$filtro = array(
	                array(
	                    "columnName" => "NRLISTA",
	                    "operator" => "=",
	                    "value" => $nrLista
	                )
	            );
				$dataSet = $this->crudService->getFilteredDataSet($this->dataSourceName, $filtro);
	            $this->crudService->delete($response, $dataSet);
	            

				$filiais_erradas  = $this->verificaParametros($filiais);
	            
				$response->addDataSet(new DataSet("RESULT", $filiais_erradas));
	            
			//	$dataSet = $this->crudService->getFilteredDataSet('lista', $rowsToSave);
			//	$this->crudService->delete($response, $dataSet);
			// } else {
			// }
		}catch (\Exception $e) {
	            $response->setError(new DTO\Response\Error($e->getMessage(), 1));
	    }
	    
	}

	public function verificaParametros($filiais ) {
	
		$stmt = $this->connection->prepare(
			"SELECT CDFILIAL, NMFILIAL 
			   FROM FILIAL F 
			  WHERE INSTR(:P_CDFILIAL,F.CDFILIAL) > 0 
				AND TIPOPARAM_DRO(F.CDFILIAL) IS NULL"
		);
		$stmt->execute(
			array('P_CDFILIAL' => $filiais)
		);
		$result = $stmt->fetchAll();
		return $result;
	}
	
}