<?php
namespace Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Teknisa\GER\Utilities\Environment;
use Zeedhi\Framework\DTO\Response\Error;

class Ger83100LancamentoDeInvestimentoPorFilial extends \Teknisa\Libs\Controller\CRUD{
	protected $dataSourceName = "filiais_dataLanc";
	protected $environment;
	protected $dataSourceNameToSave;
	protected $connection;
	protected $dataSourceManager;

	public function __construct($crudService, $environment, $dataSourceManager, $connection){
		$this->dataSourceManager = $dataSourceManager;
		$this->environment       = $environment;
		$this->crudService 		 = $crudService;
		$this->connection		 = $connection;
	}
public function atualizaInvestimento(DTO\Request $request, DTO\Response $response){
       
        $dataSet = $request->getDataSet("DataSet");
        
        if($dataSet != null){
        	$rows = $dataSet->getRows();
        	
        	foreach ($rows as $row) {
        	
	            $impostoBackupRow = $row[0];
	            $impostoCurrentRow  = $row[1];
	            
	            
	            try{
	                $stmt = $this->connection->prepare("UPDATE LANCINVEFILI
	                 SET
	                   DTINVEFILI = :P_DATA_LANCAMENTO,
	                   VRINVEFILI = :P_VALOR_INVES
	                  
	                 WHERE
	                   CDFILIAL   = :P_CDFILIAL   AND
	                   CDINVEST  = :P_CDINVEST  AND
	                   DTINVEFILI = :P_DTINVEFILI");
	    
	                $stmt->execute(
	                    array(
	                        'P_DATA_LANCAMENTO' => $impostoCurrentRow["DTINVEFILI"],
	                        'P_VALOR_INVES' => $impostoCurrentRow["VRINVEFILI"],
	                        'P_CDFILIAL' => $impostoBackupRow["CDFILIAL"],
	                        'P_CDINVEST' => $impostoBackupRow["CDINVEST"],
	                        'P_DTINVEFILI' => $impostoBackupRow["DTINVEFILI"]
	                    )
	                );
	            }catch(\Exception $ex){
	                if(strpos($ex->getMessage(), "ORA-00001") === FALSE){
	                    $response->setError(new Error("ERRO_OPERACAO2" . $ex->getMessage(), 500));
	                }else{
	                    $response->setError(new Error("Não é possível alterar. Investimento já cadastrado para essa data!", 500));
	                }
	            }
        	}
        }
    }
	

}